-- By Gustavo Alberto Lara Gómez.
function love.load()
	gr=love.graphics
	kb=love.keyboard
	mo=love.mouse
	love.window.setTitle("Game of inferno")
	gr.setDefaultFilter("nearest","nearest")
	require "cell"
	win={w=gr.getWidth(),h=gr.getHeight()}
	stay_alive_op={2,3}
	canbe_revived_op={3}
	-- Create grid:
	grid={}-- Main universe.
	grid_2={}-- To overturn new state of cells.
	for i=1,win.h do
		grid[i]={}
		grid_2[i]={}
		for j=1,win.w do
			grid[i][j]=cell:new()
			grid_2[i][j]=cell:new()
		end
	end
	scale=1
	print("columnas: "..#grid[1])
	print("filas: "..#grid)
	lienzo=gr.newCanvas(win.w,win.h)
	cm=1-- Color mode.
	changeScale(4)
end
function love.update(dt)
	-- Update cells:
	for i=1,win.h do
		for j=1,win.w do
			grid_2[i][j].hp=updateCell(i,j)
		end
	end
	for i=1,win.h do
		for j=1,win.w do
			grid[i][j].hp=grid_2[i][j].hp
		end
	end
	--love.timer.sleep(.5)
end
function love.draw()
	lienzo:clear()
	gr.setCanvas(lienzo)
	for y=1,win.h do
		for x=1,win.w do
			--if grid[y][x].alive then
			--	gr.setBackgroundColor(0,0,0)
			--	if cm==1 then
			--		gr.setColor(255,255,255)
			--	elseif cm==2 then
			--		gr.setColor(r(),r(),r())
			--	elseif cm==3 then
			--		gr.setBackgroundColor(255,255,255)
			--		gr.setColor(colorByNBN(countNB(y,x)))-- Color by neighbor number.
			--	elseif cm==4 then
			--		gr.setBackgroundColor(255,255,255)
			--		gr.setColor(grid[y][x].color)-- Innate color.
			--	end
			--	gr.point(x,y)
			--end
			local comp=grid[y][x].hp*51-- Max = 255.
			gr.setColor(comp,0,0)
			--gr.setColor(color,color,color)
			gr.point(x,y-1)
		end
	end
	gr.setCanvas()
	gr.setColor(255,255,255)
	gr.draw(lienzo,0,0,0,scale,scale)
	gr.print(os.date()..", FPS: "..love.timer.getFPS())
	--if kb.isDown("c") then
	--	gr.setColor(127,127,127,200)
	--	gr.rectangle("fill",10,10,250,20)
	--	gr.setColor(255,255,255)
	--	local t
	--	if cm==1 then t="Contrast" end
	--	if cm==2 then t="Random color cell" end
	--	if cm==3 then t="By number of neighbors" end
	--	if cm==4 then t="Innate color" end
	--	gr.print("Color mode: "..t,12,12)
	--end
end
function r() return math.random(0,255) end
function colorByNBN(nbn)
	local intensity=255-(nbn*25+55)
	return intensity,intensity,intensity
end
function updateCell(i,j)
	local nbshp=countNBSHP(i,j)
	-- If alive:
	if grid[i][j].hp>0 then
		if canStayAlive(nbs) then v=true end
	else
		if canBeRevived(nbs) then v=true end
	end
	return nbshp
end
function canStayAlive(nbs)
	local v=false
	for i=1,#stay_alive_op do
		if nbs==stay_alive_op[i] then v=true end
	end
	return v
end
function canBeRevived(nbs)
	local v=false
	for i=1,#canbe_revived_op do
		if nbs==canbe_revived_op[i] then v=true end
	end
	return v
end
function countNBSHP(i,j)
	local c=0
	if i>1 then
		if j>1 then
			if grid[i-1][j-1].hp>0 then c=c+grid[i-1][j-1].hp end-- if A.
			if grid[i-1][j].hp>0 then c=c+grid[i-1][j].hp end-- if B.
			if j<win.w then-- if C:
				if grid[i-1][j+1].hp>0 then c=c+grid[i-1][j+1].hp end
			end
		end
	end
	if j>1 then
		if grid[i][j-1].hp>0 then c=c+grid[i][j-1].hp end-- if D.
		if j<win.w then
			if grid[i][j+1].hp>0 then c=c+grid[i][j+1].hp end-- if E.
		end
		if i<win.h then
			if grid[i+1][j-1].hp>0 then c=c+grid[i+1][j-1].hp end-- if F.
			if grid[i+1][j].hp>0 then c=c+grid[i+1][j].hp end-- if G.
		end
	end
	if i<win.h and j<win.w then
		if grid[i+1][j+1].hp>0 then c=c+grid[i+1][j+1].hp end-- if H.
	end
	return c/7.995
end
function love.keypressed(key)
	if kb.isDown("lctrl") or kb.isDown("rctrl") then
		changeScale(key)
	elseif key=="c" then
		cm=cm+1
		if cm>4 then cm=1 end
	end
	if key=="q" then love.event.quit() end
end
function changeScale(key)
	local n=tonumber(key)
	if n and n>=1 and n<=7 and n~=scale then 
		love.window.setMode(win.w*n,win.h*n)
		scale=n
	end
end